/*
 * Created on 21.03.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.wfn.builduserlibs;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author riro
 */
public class ArchiveExtractor
{
	private final static Log log = LogFactory.getLog(ArchiveExtractor.class);
	private String m_libBaseDir;
	
	public ArchiveExtractor(String libBaseDir)
	{
		m_libBaseDir = libBaseDir;
	}

	
	public File extractZipEntryToDestination(File destination, ZipFile zipFile, ZipEntry zipEntry, boolean overwrite) throws IOException
	{
	    // Open the ZIP file
	    InputStream in = zipFile.getInputStream(zipEntry);
	    
	    String fileName = FileTools.filenameOfPath(zipEntry.getName()); 

	    File newFile = new File(destination.getAbsolutePath() + File.separator + fileName);
	    if (!overwrite && newFile.exists() && !FileTools.compareFiles(newFile, in))
	    {
	    	/*
	    	if (!FileTools.compareFiles(newFile, in))
	    	{
	    		throw new IOException(newFile.getAbsolutePath() + " already exists with different content.");
	    	}
	    	*/
	    	if (newFile.lastModified() >= zipEntry.getTime())
	    	{
		    	return newFile;
	    	}
	    }
	    OutputStream out = new FileOutputStream(newFile);
	
	    FileTools.copyFileContent(in, out);
	    newFile.setLastModified(zipEntry.getTime());
	    return newFile;
	}


	public File extractZipEntry(ZipFile jarFile, ZipEntry zipEntry)
	{
		File newJarFile = null;
		try {
		    // Open the ZIP file
		    InputStream in = jarFile.getInputStream(zipEntry);
		
		    // Open the output file 
		    String dirNameParts[] =  jarFile.getName().split( "\\" + File.separator);

		    String dirName = m_libBaseDir + File.separator + dirNameParts[dirNameParts.length-1].substring(0, dirNameParts[dirNameParts.length-1].lastIndexOf('.'));
		    String fileName = FileTools.filenameOfPath(zipEntry.getName()); 

		    log.debug("Extrahiere neue Datei nach " + dirName + File.separator + fileName);
		    if (!(new File(dirName)).mkdir())
		    {
		    	log.info("Directory " + dirName + " couldn't be created."); 
		    }
		    newJarFile = new File(dirName + File.separator + fileName);
		    OutputStream out = new FileOutputStream(newJarFile);
		
		    FileTools.copyFileContent(in, out);
		    newJarFile.setLastModified(zipEntry.getTime());
		} catch (IOException e) {
		}
		return newJarFile;
	}

	public File extractZipEntryWithPath(ZipFile jarFile, ZipEntry zipEntry)
	{
		File newJarFile = null;
		try {
		    // Open the ZIP file
		    InputStream in = jarFile.getInputStream(zipEntry);
		
		    // Open the output file 
		    String dirNameParts[] =  jarFile.getName().split( "\\" + File.separator);

		    String dirName = m_libBaseDir + File.separator + dirNameParts[dirNameParts.length-1].substring(0, dirNameParts[dirNameParts.length-1].lastIndexOf('.'));
		    String fileName = FileTools.filenameOfPath(zipEntry.getName()); 

		    log.debug("Extrahiere neue Datei nach " + dirName + File.separator + fileName);
		    if (!(new File(dirName)).mkdir())
		    {
		    	log.info("Directory " + dirName + " couldn't be created."); 
		    }
		    newJarFile = new File(dirName + File.separator + fileName);
		    OutputStream out = new FileOutputStream(newJarFile);
		
		    FileTools.copyFileContent(in, out);
		    newJarFile.setLastModified(zipEntry.getTime());
		} catch (IOException e) {
		}
		return newJarFile;
	}
	
}
