/*
 * Created on 17.04.2005
 */
package de.wfn.builduserlibs;

import java.io.IOException;

/**
 * Exception indicates that a give File already exists.
 * @author Jens-Oliver Siepmann
 */
public class FileExistsException extends IOException
{
	/**
	 * Comment for <code>serialVersionUID</code>
	 */
	private static final long serialVersionUID = 3618418220622126759L;

	/**
	 * Default constructor. Affected file is not supplied. Don't use it.
	 */
	public FileExistsException ()
	{
		super();
	}

	/**
	 * Constructor for supplying affected file.
	 * @param file which already exists.
	 */
	public FileExistsException (String file)
	{
		super(file);
	}
}
