/*
 * Created on 14.05.2005 
 */
package de.wfn.builduserlibs.packageanalyse;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import de.wfn.builduserlibs.FileTools;

/**
 * Manages java documentation packages.
 * @author Jens-Oliver Siepmann
 *
 */
public class DocPackageList extends PackageList
{
	private String m_path;
	private String m_fileName;
	private String m_zipPath;
	
	public DocPackageList(ZipFile file, ZipEntry entry)
	{
		m_path = FileTools.pathOf(file.getName());
		m_fileName = FileTools.filenameOfPath(file.getName());
		m_zipPath = FileTools.pathOf(entry);
	}
	
	public URL getContainerURL()
	{
		try
		{
			URL tempUrl = new File(m_path + File.separatorChar + m_fileName).toURL();
			String tempUrlStr = "jar:" + tempUrl.toExternalForm() + "!/" + m_zipPath;
			return new URL(tempUrlStr);
		}
		catch (MalformedURLException e)
		{
			throw new RuntimeException(e);
		}
	}

	public void setPath(String path)
	{
		m_path = path;
	}

	public static void main(String[] args)
	{
		try
		{
			ZipFile zipFile = new ZipFile("R:/lib/commons-net-1.3.0.zip");
			ZipEntry zipEntry = zipFile.getEntry("commons-net-1.3.0/docs/api/package-list");
			DocPackageList docPkgLst = new DocPackageList(zipFile, zipEntry);
			System.out.println(docPkgLst.getContainerURL().toExternalForm());
			docPkgLst.setPath("C:\\OLIVER");
			System.out.println(docPkgLst.getContainerURL().toExternalForm());
		}
		catch(IOException e)
		{
		}
	}
}
