/*
 * Created on 13.05.2005 
 */
package de.wfn.builduserlibs.packageanalyse;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.zip.ZipFile;

import de.wfn.builduserlibs.FileTools;

/**
 * Manages Java source packages.
 * @author Jens-Oliver Siepmann
 */
public class SourcePackageList extends PackageList
{
	private String m_path;
	private String m_fileName;
	
	public SourcePackageList(ZipFile file)
	{
		m_path = FileTools.pathOf(file.getName());
		m_fileName = FileTools.filenameOfPath(file.getName());
	}
	
	public URL getContainerURL()
	{
		try
		{
			return new File(m_path + File.separatorChar + m_fileName).toURL();
		}
		catch (MalformedURLException e)
		{
			throw new RuntimeException(e);
		}
	}
	
	public void setPath(String path)
	{
		m_path = path;
	}
}
