/*
 * Created on 28.03.2005
 */
package de.wfn.builduserlibs.page;

import org.apache.log4j.Logger;
import org.eclipse.jface.wizard.IWizard;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Tree;

import de.wfn.builduserlibs.Model;


/**
 * On this wizard page the user libraries names are edited and the zip files
 * of which the user libraries are constructed are managed. (assignment, removement)
 * @author riro
 */
public class ZipFileSelectionPage extends WizardPage
{
	private static final Logger log = Logger.getLogger(ZipFileSelectionPage.class);

	private Model m_model;
	private ZipFileSelectionPageView m_view;
	private Tree m_tree;

	public ZipFileSelectionPage(String pageName, Model model)
	{
		super(pageName);
		m_model = model;
		m_view = new ZipFileSelectionPageView(this, m_model);
	}

	public void createControl(Composite parent)
	{
		Composite composite = new Composite(parent, SWT.NONE);
		FillLayout gridLayout = new FillLayout();
		composite.setLayout(gridLayout);
		
		m_tree = m_view.createTreeControl(composite);
 
		GridData data = new GridData(); // 622126759
		data.horizontalAlignment = GridData.FILL;
		data.horizontalSpan = 3;
		data.grabExcessHorizontalSpace = true;
		m_tree.setLayoutData(data);
	
		setControl(composite);
	}

	public Tree getTree()
	{
		return m_tree;
	}
	
    public IWizard getWizard() 
    {
    	m_model.scanZipFiles(getTree());
        return super.getWizard();
    }
	
}
